| garciadeblas | 93c6131 | 2016-09-28 15:12:48 +0200 | [diff] [blame] | 1 | #!/bin/bash |
| garciadeblas | 38d91ee | 2019-11-07 16:31:23 +0100 | [diff] [blame] | 2 | # |
| 3 | # Licensed under the Apache License, Version 2.0 (the "License"); |
| 4 | # you may not use this file except in compliance with the License. |
| 5 | # You may obtain a copy of the License at |
| 6 | # |
| 7 | # http://www.apache.org/licenses/LICENSE-2.0 |
| 8 | # |
| 9 | # Unless required by applicable law or agreed to in writing, software |
| 10 | # distributed under the License is distributed on an "AS IS" BASIS, |
| 11 | # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| 12 | # See the License for the specific language governing permissions and |
| 13 | # limitations under the License. |
| 14 | # |
| garciadeblas | d8bc5c3 | 2018-05-09 17:37:56 +0200 | [diff] [blame] | 15 | REPOSITORY_BASE=https://osm-download.etsi.org/repository/osm/debian |
| garciadeblas | f407c45 | 2024-08-22 14:23:40 +0200 | [diff] [blame] | 16 | RELEASE=ReleaseSIXTEEN |
| garciadeblas | 7bcadc5 | 2020-02-02 22:40:15 +0100 | [diff] [blame] | 17 | REPOSITORY=stable |
| garciadeblas | 931a512 | 2023-10-03 17:52:02 +0200 | [diff] [blame] | 18 | DOCKER_TAG="testing-daily" |
| garciadeblas | 2bf767a | 2021-05-19 10:54:46 +0200 | [diff] [blame] | 19 | DEVOPS_PATH=/usr/share/osm-devops |
| garciadeblas | 93c6131 | 2016-09-28 15:12:48 +0200 | [diff] [blame] | 20 | |
| garciadeblas | 38d91ee | 2019-11-07 16:31:23 +0100 | [diff] [blame] | 21 | function usage(){ |
| 22 | echo -e "usage: $0 [OPTIONS]" |
| garciadeblas | 81077ae | 2023-07-03 19:31:15 +0200 | [diff] [blame] | 23 | echo -e "Install OSM" |
| garciadeblas | 38d91ee | 2019-11-07 16:31:23 +0100 | [diff] [blame] | 24 | echo -e " OPTIONS" |
| garciadeblas | 7f1e104 | 2020-11-30 14:07:03 +0000 | [diff] [blame] | 25 | echo -e " -h / --help: print this help" |
| 26 | echo -e " -y: do not prompt for confirmation, assumes yes" |
| garciadeblas | 38d91ee | 2019-11-07 16:31:23 +0100 | [diff] [blame] | 27 | echo -e " -r <repo>: use specified repository name for osm packages" |
| khelifi | bca8331 | 2025-06-17 16:06:23 +0200 | [diff] [blame] | 28 | echo -e " -R <release>: use specified release for osm binaries (deb packages, ...)" |
| garciadeblas | 38d91ee | 2019-11-07 16:31:23 +0100 | [diff] [blame] | 29 | echo -e " -u <repo base>: use specified repository url for osm packages" |
| 30 | echo -e " -k <repo key>: use specified repository public key url" |
| garciadeblas | 9615504 | 2022-06-22 16:26:22 +0200 | [diff] [blame] | 31 | echo -e " -a <apt proxy url>: use this apt proxy url when downloading apt packages (air-gapped installation)" |
| garciadeblas | 8d8cd99 | 2024-05-21 16:04:14 +0200 | [diff] [blame] | 32 | echo -e " -c <kubernetes engine>: use a specific kubernetes engine (options: kubeadm, k3s), default is kubeadm" |
| 33 | echo -e " -t <docker tag> specify osm docker tag (default is latest)" |
| 34 | echo -e " -M <KUBECONFIG_FILE>: Kubeconfig of an existing cluster to be used as mgmt cluster instead of OSM cluster" |
| 35 | echo -e " -G <KUBECONFIG_FILE>: Kubeconfig of an existing cluster to be used as auxiliary cluster instead of OSM cluster" |
| garciadeblas | cf603f5 | 2025-06-04 11:57:28 +0200 | [diff] [blame] | 36 | echo -e " -O <KUBECONFIG_FILE>: Kubeconfig of an existing cluster to be used as OSM cluster instead of creating a new one from scratch" |
| garciadeblas | 8d8cd99 | 2024-05-21 16:04:14 +0200 | [diff] [blame] | 37 | echo -e " --no-mgmt-cluster: Do not provision a mgmt cluster for cloud-native gitops operations in OSM (NEW in Release SIXTEEN) (by default, it is installed)" |
| 38 | echo -e " --no-aux-cluster: Do not provision an auxiliary cluster for cloud-native gitops operations in OSM (NEW in Release SIXTEEN) (by default, it is installed)" |
| 39 | echo -e " -D <devops path>: use local devops installation path" |
| garciadeblas | 81077ae | 2023-07-03 19:31:15 +0200 | [diff] [blame] | 40 | echo -e " -s <namespace> namespace when installed using k8s, default is osm" |
| garciadeblas | 8d8cd99 | 2024-05-21 16:04:14 +0200 | [diff] [blame] | 41 | echo -e " -w <work dir>: Location to store runtime installation" |
| David Garcia | 404ae12 | 2020-04-28 11:47:55 +0200 | [diff] [blame] | 42 | echo -e " -K: Specifies the name of the controller to use - The controller must be already bootstrapped" |
| garciadeblas | 7f1e104 | 2020-11-30 14:07:03 +0000 | [diff] [blame] | 43 | echo -e " -d <docker registry URL> use docker registry URL instead of dockerhub" |
| 44 | echo -e " -p <docker proxy URL> set docker proxy URL as part of docker CE configuration" |
| garciadeblas | 9a51086 | 2021-04-21 14:15:56 +0200 | [diff] [blame] | 45 | echo -e " -T <docker tag> specify docker tag for the modules specified with option -m" |
| garciadeblas | 9615504 | 2022-06-22 16:26:22 +0200 | [diff] [blame] | 46 | echo -e " --debug: debug mode" |
| garciadeblas | 38d91ee | 2019-11-07 16:31:23 +0100 | [diff] [blame] | 47 | echo -e " --uninstall: uninstall OSM: remove the containers and delete NAT rules" |
| garciadeblas | 38d91ee | 2019-11-07 16:31:23 +0100 | [diff] [blame] | 48 | } |
| 49 | |
| garciadeblas | d8bc5c3 | 2018-05-09 17:37:56 +0200 | [diff] [blame] | 50 | add_repo() { |
| 51 | REPO_CHECK="^$1" |
| 52 | grep "${REPO_CHECK/\[arch=amd64\]/\\[arch=amd64\\]}" /etc/apt/sources.list > /dev/null 2>&1 |
| 53 | if [ $? -ne 0 ] |
| 54 | then |
| garciadeblas | bd925e4 | 2018-06-14 14:32:12 +0200 | [diff] [blame] | 55 | need_packages_lw="software-properties-common apt-transport-https" |
| garciadeblas | 0bc8752 | 2021-10-20 22:16:17 +0200 | [diff] [blame] | 56 | echo -e "Checking required packages to add ETSI OSM debian repo: $need_packages_lw" |
| garciadeblas | bd925e4 | 2018-06-14 14:32:12 +0200 | [diff] [blame] | 57 | dpkg -l $need_packages_lw &>/dev/null \ |
| 58 | || ! echo -e "One or several required packages are not installed. Updating apt cache requires root privileges." \ |
| garciadeblas | 5f420b1 | 2022-02-10 01:43:59 +0100 | [diff] [blame] | 59 | || sudo apt-get -qy update \ |
| Mike Marchetti | 3412418 | 2018-10-16 08:22:30 -0400 | [diff] [blame] | 60 | || ! echo "failed to run apt-get update" \ |
| garciadeblas | bd925e4 | 2018-06-14 14:32:12 +0200 | [diff] [blame] | 61 | || exit 1 |
| 62 | dpkg -l $need_packages_lw &>/dev/null \ |
| 63 | || ! echo -e "Installing $need_packages_lw requires root privileges." \ |
| 64 | || sudo apt-get install -y $need_packages_lw \ |
| Mike Marchetti | 3412418 | 2018-10-16 08:22:30 -0400 | [diff] [blame] | 65 | || ! echo "failed to install $need_packages_lw" \ |
| garciadeblas | bd925e4 | 2018-06-14 14:32:12 +0200 | [diff] [blame] | 66 | || exit 1 |
| garciadeblas | cf603f5 | 2025-06-04 11:57:28 +0200 | [diff] [blame] | 67 | curl -s -o OSM-ETSI-Release-key.gpg "$REPOSITORY_BASE/$RELEASE/OSM%20ETSI%20Release%20Key.gpg" |
| garciadeblas | bc97a01 | 2022-04-21 00:29:02 +0200 | [diff] [blame] | 68 | sudo APT_KEY_DONT_WARN_ON_DANGEROUS_USAGE=1 apt-key add OSM-ETSI-Release-key.gpg \ |
| 69 | || ! echo -e "Could not add GPG key $REPOSITORY_BASE/$RELEASE/OSM%20ETSI%20Release%20Key.gpg" \ |
| 70 | || exit 1 |
| garciadeblas | 5f420b1 | 2022-02-10 01:43:59 +0100 | [diff] [blame] | 71 | sudo DEBIAN_FRONTEND=noninteractive add-apt-repository -y "$1" |
| garciadeblas | bc97a01 | 2022-04-21 00:29:02 +0200 | [diff] [blame] | 72 | sudo DEBIAN_FRONTEND=noninteractive apt-get -y update |
| garciadeblas | 429b9f8 | 2018-03-20 02:09:44 +0100 | [diff] [blame] | 73 | return 0 |
| garciadeblas | d8bc5c3 | 2018-05-09 17:37:56 +0200 | [diff] [blame] | 74 | fi |
| 75 | |
| 76 | return 1 |
| garciadeblas | 55490d4 | 2016-10-29 14:22:03 +0200 | [diff] [blame] | 77 | } |
| 78 | |
| garciadeblas | 25e87d2 | 2020-01-31 14:27:29 +0100 | [diff] [blame] | 79 | clean_old_repo() { |
| madavi | ae0784f | 2020-01-22 16:29:19 +0530 | [diff] [blame] | 80 | dpkg -s 'osm-devops' &> /dev/null |
| madavi | ae0784f | 2020-01-22 16:29:19 +0530 | [diff] [blame] | 81 | if [ $? -eq 0 ]; then |
| madavi | ae0784f | 2020-01-22 16:29:19 +0530 | [diff] [blame] | 82 | # Clean the previous repos that might exist |
| 83 | sudo sed -i "/osm-download.etsi.org/d" /etc/apt/sources.list |
| 84 | fi |
| 85 | } |
| 86 | |
| garciadeblas | 0bc8752 | 2021-10-20 22:16:17 +0200 | [diff] [blame] | 87 | function configure_apt_proxy() { |
| 88 | [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function |
| 89 | OSM_APT_PROXY=$1 |
| 90 | OSM_APT_PROXY_FILE="/etc/apt/apt.conf.d/osm-apt" |
| 91 | echo "Configuring apt proxy in file ${OSM_APT_PROXY_FILE}" |
| 92 | if [ ! -f ${OSM_APT_PROXY_FILE} ]; then |
| 93 | sudo bash -c "cat <<EOF > ${OSM_APT_PROXY} |
| 94 | Acquire::http { Proxy \"${OSM_APT_PROXY}\"; } |
| 95 | EOF" |
| 96 | else |
| 97 | sudo sed -i "s|Proxy.*|Proxy \"${OSM_APT_PROXY}\"; }|" ${OSM_APT_PROXY_FILE} |
| 98 | fi |
| garciadeblas | 5f420b1 | 2022-02-10 01:43:59 +0100 | [diff] [blame] | 99 | sudo apt-get -y update || FATAL "Configured apt proxy, but couldn't run 'apt-get update'. Check ${OSM_APT_PROXY_FILE}" |
| garciadeblas | 0bc8752 | 2021-10-20 22:16:17 +0200 | [diff] [blame] | 100 | [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function |
| 101 | } |
| 102 | |
| garciadeblas | cf603f5 | 2025-06-04 11:57:28 +0200 | [diff] [blame] | 103 | while getopts ":a:c:e:r:k:u:R:D:s:t:U:d:p:T:M:G:O:-: hy" o; do |
| garciadeblas | 38d91ee | 2019-11-07 16:31:23 +0100 | [diff] [blame] | 104 | case "${o}" in |
| Antonio Marsico | 75a38c7 | 2020-12-21 17:29:42 +0100 | [diff] [blame] | 105 | D) |
| 106 | DEVOPS_PATH="${OPTARG}" |
| 107 | ;; |
| garciadeblas | 38d91ee | 2019-11-07 16:31:23 +0100 | [diff] [blame] | 108 | r) |
| 109 | REPOSITORY="${OPTARG}" |
| 110 | ;; |
| 111 | R) |
| 112 | RELEASE="${OPTARG}" |
| 113 | ;; |
| 114 | u) |
| 115 | REPOSITORY_BASE="${OPTARG}" |
| 116 | ;; |
| 117 | t) |
| garciadeblas | 25e87d2 | 2020-01-31 14:27:29 +0100 | [diff] [blame] | 118 | DOCKER_TAG="${OPTARG}" |
| garciadeblas | 38d91ee | 2019-11-07 16:31:23 +0100 | [diff] [blame] | 119 | ;; |
| garciadeblas | 72399e3 | 2019-11-22 10:09:40 +0100 | [diff] [blame] | 120 | -) |
| 121 | [ "${OPTARG}" == "help" ] && usage && exit 0 |
| Dominik Fleischmann | 5e4a751 | 2020-03-06 14:05:06 +0100 | [diff] [blame] | 122 | ;; |
| garciadeblas | 25e87d2 | 2020-01-31 14:27:29 +0100 | [diff] [blame] | 123 | :) |
| 124 | echo "Option -$OPTARG requires an argument" >&2 |
| 125 | usage && exit 1 |
| 126 | ;; |
| 127 | \?) |
| 128 | echo -e "Invalid option: '-$OPTARG'\n" >&2 |
| 129 | usage && exit 1 |
| 130 | ;; |
| 131 | h) |
| 132 | usage && exit 0 |
| 133 | ;; |
| garciadeblas | 38d91ee | 2019-11-07 16:31:23 +0100 | [diff] [blame] | 134 | *) |
| 135 | ;; |
| 136 | esac |
| 137 | done |
| 138 | |
| garciadeblas | 25e87d2 | 2020-01-31 14:27:29 +0100 | [diff] [blame] | 139 | clean_old_repo |
| garciadeblas | d8bc5c3 | 2018-05-09 17:37:56 +0200 | [diff] [blame] | 140 | add_repo "deb [arch=amd64] $REPOSITORY_BASE/$RELEASE $REPOSITORY devops" |
| garciadeblas | 5f420b1 | 2022-02-10 01:43:59 +0100 | [diff] [blame] | 141 | sudo DEBIAN_FRONTEND=noninteractive apt-get -qy update |
| 142 | sudo DEBIAN_FRONTEND=noninteractive apt-get -y install osm-devops |
| Antonio Marsico | 75a38c7 | 2020-12-21 17:29:42 +0100 | [diff] [blame] | 143 | $DEVOPS_PATH/installers/full_install_osm.sh -R $RELEASE -r $REPOSITORY -u $REPOSITORY_BASE -D $DEVOPS_PATH -t $DOCKER_TAG "$@" |